#pragma once

#include <string>

#include "DepNode.h"
#include "toolchain.h"

class LinkStep: public DepNode {
public:
	LinkStep(std::string path, toolchain::TargetType type):
		path_(path), type_(type) {}

private:
	std::string path_;
	toolchain::TargetType type_;

	bool checkHasChanged(const std::string &outDir) override;
	void doBuild(const std::string &outDir) override;

	bool hasLinkCommand_ = false;
	std::vector<std::string> linkCommand_;
	std::vector<std::string> &linkCommand(const std::string &outDir);

	std::string confPath(const std::string &outDir) { return outDir + '/' + path_ + ".bx"; }
};
